/*
 * Copyright 2014 Peter Olsson
 * 
 * This file is part of Brum Brum Rally.
 * 
 * Brum Brum Rally is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Brum Brum Rally is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef POINTER_H
#define POINTER_H

#include "RenderObject.h"
#include <vector>

class Pointer
{
public:
	Pointer();
	void move(int x, int y);
	void hide(bool force = false);
	void show();
	void setScaling(bool scaling);
	void setType(const std::string& name);
	void setFullScreen(bool fullscreen);
	void draw(Surface& screen);
	bool isUpdated() const;
	bool isVisible() const;
	void updateRects(Rect& newRect, Rect& oldRect);
	void update(bool notNeeded);
	static const std::vector<std::string>& getList();
	
private:
	RenderObject ro;
	int offsetX;
	int offsetY;
	int hideTimer;
	
	bool visible;
	bool scale;
	SDL_Cursor* cursor;
	bool fullscreen;
	bool outside;
};

#endif
